## caffe-contrib 1.0.0+git20180821.99bd997

=== CMakeLists.txt ===
file(GLOB_RECURSE examples_srcs "${PROJECT_SOURCE_DIR}/examples/*.cpp")

foreach(source_file ${examples_srcs})
  # get file name
  get_filename_component(name ${source_file} NAME_WE)
    
  # get folder name
  get_filename_component(path ${source_file} PATH)
  get_filename_component(folder ${path} NAME_WE)
    
  add_executable(${name} ${source_file})
  target_link_libraries(${name} ${Caffe_LINK})
  caffe_default_properties(${name})

  # set back RUNTIME_OUTPUT_DIRECTORY
  set_target_properties(${name} PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/examples/${folder}")

  caffe_set_solution_folder(${name} examples)

  # install
  install(TARGETS ${name} DESTINATION ${CMAKE_INSTALL_BINDIR})


  if(UNIX OR APPLE)
    # Funny command to make tutorials work
    # TODO: remove in future as soon as naming is standardized everywhere
    set(__outname ${PROJECT_BINARY_DIR}/examples/${folder}/${name}${Caffe_POSTFIX})
    add_custom_command(TARGET ${name} POST_BUILD
                       COMMAND ln -sf "${__outname}" "${__outname}.bin")
  endif()
endforeach()

=== caffe/CMakeLists.txt ===
# generate protobuf sources
file(GLOB proto_files proto/*.proto)
caffe_protobuf_generate_cpp_py(${proto_gen_folder} proto_srcs proto_hdrs proto_python ${proto_files})

# include python files either to force generation
add_library(caffeproto STATIC ${proto_hdrs} ${proto_srcs} ${proto_python})
caffe_default_properties(caffeproto)
target_link_libraries(caffeproto PUBLIC ${PROTOBUF_LIBRARIES})
target_include_directories(caffeproto PUBLIC ${PROTOBUF_INCLUDE_DIR})

list(INSERT Caffe_LINKER_LIBS 0 PUBLIC caffeproto) # note, crucial to prepend!

# --[ Caffe library

# creates 'test_srcs', 'srcs', 'test_cuda', 'cuda' lists
caffe_pickup_caffe_sources(${PROJECT_SOURCE_DIR})

if(HAVE_CUDA)
  caffe_cuda_compile(cuda_objs ${cuda})
  list(APPEND srcs ${cuda_objs} ${cuda})
endif()

add_library(caffe ${srcs})
caffe_default_properties(caffe)
target_link_libraries(caffe ${Caffe_LINKER_LIBS})
target_include_directories(caffe ${Caffe_INCLUDE_DIRS}
                                 PUBLIC
                                 $<BUILD_INTERFACE:${Caffe_INCLUDE_DIR}>
                                 $<INSTALL_INTERFACE:include>)
target_compile_definitions(caffe ${Caffe_DEFINITIONS})
if(Caffe_COMPILE_OPTIONS)
  target_compile_options(caffe ${Caffe_COMPILE_OPTIONS})
endif()
set_target_properties(caffe PROPERTIES
    VERSION   ${CAFFE_TARGET_VERSION}
    SOVERSION ${CAFFE_TARGET_SOVERSION}
    )

# ---[ Tests
 add_subdirectory(test)

# ---[ Install
install(DIRECTORY ${Caffe_INCLUDE_DIR}/caffe DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES ${proto_hdrs} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/caffe/proto)
install(TARGETS caffe caffeproto EXPORT CaffeTargets DESTINATION ${CMAKE_INSTALL_LIBDIR})

file(WRITE ${PROJECT_BINARY_DIR}/__init__.py)
list(APPEND proto_python ${PROJECT_BINARY_DIR}/__init__.py)
install(PROGRAMS ${proto_python} DESTINATION python/caffe/proto)

=== debian/changelog ===
caffe-contrib (1.0.0+git20180821.99bd997-2) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Build with CUDA 9.2 and GCC 7.  (Closes: #892388)

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 10 Jan 2019 23:16:27 +0000

caffe-contrib (1.0.0+git20180821.99bd997-1) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Fix finding the right boost-python. (1.0.0-8ubuntu1)

  [ Steve Langasek ]
  * Add versioned dep, build-dep on python-protobuf since the python
    module is not runtime-compatible with older versions of the package.
    (src:caffe-contrib_1.0.0-8ubuntu5)

  [ Mo Zhou ]
  * New upstream version 1.0.0+git20180821.99bd997
  * Bump Standards-Version to 4.2.0 (no change).
  * Deprecate the X-Python-Version field.
  * Package caffe-cuda doesn't need to Depend on
    libopenblas-base | libatlas3-base | libblas.so.3 .
  * Package libcaffe-cuda1 now Depends libopenblas-base | libatlas3-base |
    libblas.so.3, and Suggests intel-mkl (See: #898941)
  * Allow output to stderr during autopkgtest. (unblocks Ubuntu migration)

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 06 Dec 2018 04:10:07 +0000

caffe-contrib (1.0.0-8) unstable; urgency=medium

  * Install upstream unit test tool as »caffe-gtest«.
  * B-D on python3-distutils. (See: #894203)
  * Remove unneeded argument --parallel due to debhelper compat 11.
  * Update package description, adding a comment about unittest.
  * Bump X-Python-Version to >= 3.5 .
  * Bump Standards-Version to 4.1.4 (no change).
  * Update watch file to version 4.
  * Add a test to run upstream unit tests.
  * Modify flags passed to NVCC to avoid test failure caused by a
    CUDA 9.1 bug. Although this change may lead to a computing speed drop.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 27 May 2018 06:36:56 +0000

caffe-contrib (1.0.0-7) UNRELEASED; urgency=medium

  * Simply bump debian revision so that the version number is
    synchronized with CPU version of caffe.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 26 May 2018 13:24:32 +0000

=== debian/control ===
Source: caffe-contrib
Section: contrib/science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <cdluminate@gmail.com>
Build-Depends: bc,
               cmake,
               bash-completion,
               debhelper (>=11~),
               dh-python,
               git,
# libboost-all-dev (>= 1.55) - we merely pull partial boost stack, the really needed part.
               libboost-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-python-dev,
               libgflags-dev,
               libgoogle-glog-dev,
               libhdf5-dev,
               libleveldb-dev,
               liblmdb-dev,
# switch libblas.so.3 between Atlas and OpenBLAS with update-alternatives
               libblas-dev | libblas.so,
               libopencv-dev (>= 2.4),
               libprotobuf-dev,
               libprotoc-dev,
               libsnappy-dev,
               protobuf-compiler,
# python3 depssome of them are not B-D but we need them as runtime-deps to pass the testsuite
               python3-dev,
               python3-numpy,
               cython3,
               ipython3,
               python3,
               python3-distutils,
               python3-skimage,
               python3-protobuf,
               python3-dateutil,
               python3-gflags,
               python3-h5py,
               python3-leveldb,
               python3-matplotlib,
               python3-networkx,
               python3-nose,
#              python3-opencv, # this is recommended if available but it doesn't block
               python3-pandas,
               python3-pil,
               python3-pydotplus,
               python3-scipy,
               python3-six,
               python3-yaml,
# The above part is synced with main/caffe
# The following part is CUDA related B-D
               nvidia-cuda-toolkit (>= 9.2) [amd64 ppc64el],
               g++-7,
Standards-Version: 4.2.0
Homepage: http://caffe.berkeleyvision.org
Vcs-Browser: https://salsa.debian.org/science-team/caffe-contrib
Vcs-Git: https://salsa.debian.org/science-team/caffe-contrib.git

Package: caffe-cuda
Section: contrib/metapackages
Architecture: amd64 ppc64el
Depends: caffe-tools-cuda   (= ${binary:Version}),
         python3-caffe-cuda (= ${binary:Version}),
         libcaffe-cuda1     (= ${binary:Version}),
         ${misc:Depends},
         python3-protobuf (>= 3.6.1~),
Suggests: libcaffe-cuda-dev  (= ${binary:Version}),
          caffe-doc,
Conflicts: caffe-cpu
Description: Fast, open framework for Deep Learning (Meta)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 This metapackage pulls CUDA version of caffe:
  * caffe-tools-cuda
  * libcaffe-cuda*
  * python3-caffe-cuda
 And suggests these packages:
  * libcaffe-cuda-dev
  * caffe-doc
 .
 Note, this CUDA version cannot co-exist with the CPU_ONLY version.

Package: caffe-tools-cuda
Architecture: amd64 ppc64el
Multi-Arch: foreign
Depends: libcaffe-cuda1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: caffe-tools-cpu
Description: Tools for fast, open framework for Deep Learning (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 It contains caffe executables, configured with CUDA.
 .
 Issue this command at the root of caffe source tree for a unit test:
   $ caffe-gtest --gtest_shuffle

Package: libcaffe-cuda1
Section: contrib/libs
Architecture: amd64 ppc64el
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libopenblas-base | libatlas3-base | libblas.so.3,
Suggests: intel-mkl,
Conflicts: libcaffe-cpu1
Description: library of Caffe, deep leanring framework (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR)and community contributors.
 .
 It contains caffe shared library, configured with CUDA.

Package: libcaffe-cuda-dev
Section: contrib/libdevel
Architecture: amd64 ppc64el
Multi-Arch: same
Depends: libcaffe-cuda1 (= ${binary:Version}), ${misc:Depends}
Conflicts: libcaffe-cpu-dev
Suggests: caffe-doc
Description: development files for Caffe (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 It contains the development files of caffe.

Package: python3-caffe-cuda
Section: contrib/python
Architecture: amd64 ppc64el
Multi-Arch: foreign
Depends: libcaffe-cuda1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
         python3-protobuf (>= 3.6.1~),
Conflicts: python3-caffe-cpu
Description: Python3 interface of Caffe (CUDA)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley AI Research
 Lab (BAIR) and community contributors.
 .
 It contains the CUDA version of python3 Caffe interface.

# caffe-doc is built by main/caffe, the CPU version.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# Hardening Caffe according to https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS   = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed

# Try this if it fails to build with a new glibc.
# Thanks to Gianfranco Costamagna <locutusofborg@debian.org>
#export DEB_CFLAGS_MAINT_APPEND   = -Wall -D_GLIBCXX_USE_C99_MATH=1
#export DEB_CXXFLAGS_MAINT_APPEND = -Wall -D_GLIBCXX_USE_C99_MATH=1

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
RULES         := debian/rules
ORIG_SOURCE   := "https://github.com/BVLC/caffe/archive/1.0.tar.gz"
CAFFE_SOVER   := 1.0.0
BUILDDIR      := "caffe_cuda_build"

TEMPLATES     := $(wildcard debian/*.in)
AUTOGEN       := $(patsubst %.in,%,$(TEMPLATES))

## CMake Configuration Template.
## Should sync this with the caffe CPU_ONLY version.
CMAKE_CONFIGURE_TEMPLATE = \
	-DALLOW_LMDB_NOLOCK=OFF \
	-DBLAS="Generic" \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_docs=OFF \
	-DBUILD_matlab=OFF \
	-DBUILD_python=ON \
	-DBUILD_python_layer=ON \
	-Dpython_version="3" \
	-DCMAKE_BUILD_TYPE="Release" \
	-DCMAKE_C_FLAGS="$(CFLAGS) $(CPPFLAGS)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)" \
	-DCMAKE_SKIP_RPATH=TRUE \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DUSE_CUDNN=OFF \
	-DUSE_LEVELDB=ON \
	-DUSE_LMDB=ON \
	-DUSE_OPENCV=ON \
	-DCPU_ONLY=$(FILL_THIS_BLANK) \
	-DCMAKE_INSTALL_PREFIX="/usr"

CONFFLAG_CUDA = \
	$(CMAKE_CONFIGURE_TEMPLATE) \
	-DCPU_ONLY=OFF \
	-DCUDA_ARCH_NAME="All" \
	-DCMAKE_CXX_COMPILER=g++-7 \
	-DCMAKE_C_COMPILER=gcc-7 \


%:: %.in
	perl -p \
	-e 's{#CAFFE_CONFIGURE#}{caffe_cuda}g;' \
	-e 's{#CAFFE_SOVER#}{$(CAFFE_SOVER)}g;' \
	-e 's{#DEB_HOST_MULTIARCH#}{$(DEB_HOST_MULTIARCH)}g;' \
	< $< > $@

%:
	dh $@ \
		--buildsystem=cmake \
		--with python3,bash-completion

override_dh_auto_configure: $(AUTOGEN)
	dh_auto_configure --builddirectory=$(BUILDDIR) \
		-- $(CONFFLAG_CUDA)

override_dh_auto_clean:
	dh_auto_clean --builddirectory=$(BUILDDIR)
	-$(RM) -rf python/caffe/proto/ doxygen
	-$(RM) python/caffe/_caffe.so
	-find . -type d -name '__pycache__' -exec rm -rf '{}' +

override_dh_auto_build:
	dh_auto_build --builddirectory=$(BUILDDIR) \
		-- caffe pycaffe test.testbin all

# In the test phase, we need to set LD_LIBRARY_PATH properly
# for those test ELFs linked with libcaffe.so.X
override_dh_auto_test:
	# the i386/amd64 build machine may have no CUDA-capable
	# video card. Hence heading with a dash.
	-dh_auto_test --builddirectory=$(BUILDDIR) \
		-- runtest pytest LD_LIBRARY_PATH=$(shell pwd)/$(BUILDDIR)/lib/

override_dh_python3:
	dh_python3 --requires=python/requirements.txt
	dh_numpy3

override_dh_install:
	dh_install
	# The upstream unittest can be used to verify the BLAS correctness.
	mv caffe_cuda_build/test/test.testbin  caffe-gtest
	install -m0755 caffe-gtest debian/caffe-tools-cuda/usr/bin/
	dh_missing --list-missing

override_dh_auto_install:
	dh_auto_install --builddirectory=$(BUILDDIR) -- install

override_dh_makeshlibs:
	dh_makeshlibs --package=python3-caffe-cuda -X/usr/lib/python
	dh_makeshlibs --remaining-packages

override_dh_fixperms:
	dh_fixperms
	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/caffe_pb2.py
	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/__init__.py

get-orig-source:
	wget -c $(ORIG_SOURCE) -O caffe_1.0.0.orig.tar.gz

=== debian/tests/control ===
Tests: simply.run

Tests: test.forward.backward.lenet

Tests: test.python3.import

Tests: test.python3.simple.forward

# This test is allowed to fail because it requires GPU
Test-Command: caffe-gtest --gtest_shuffle || true
Depends: @
Restrictions: allow-stderr
